(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-keyboard-shortcuts', ['exports', '@angular/core', '@angular/common'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ngx-keyboard-shortcuts'] = {}, global.ng.core, global.ng.common));
}(this, (function (exports, i0, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var KeyboardShortcutListener = /** @class */ (function () {
        function KeyboardShortcutListener(listenerConstructorObject, blackListedKeyboardShortcutChecker) {
            // assign properties based on constructor and defaults
            var defaultListenerOptions = {
                ignoreEventsFromInputElement: false,
                passToLowerPriorities: true,
                priority: 0
            };
            Object.assign(this, defaultListenerOptions, listenerConstructorObject);
            // assign mapped keyboard shortcut combination
            this.mappedKeyboardShortcutCombination = mapKeyboardShortcutCombination(this.keyBinding);
            // assign display shortcut combination
            var copyOfKeyBinding = __spread(this.keyBinding);
            copyOfKeyBinding.sort(function (a, b) {
                if (a.length > 1 && b.length === 1) {
                    return -1;
                }
                else if (a.length === 1 && b.length > 1) {
                    return 1;
                }
                else if (a > b) {
                    return 1;
                }
                else if (a < b) {
                    return -1;
                }
                else {
                    return 0;
                }
            });
            this.displayShortcutCombination = copyOfKeyBinding
                .map(function (kb) { return kb.replace(/^\w/, function (c) { return c.toUpperCase(); }); })
                .join(' + ');
            // check vs blacklist
            if (blackListedKeyboardShortcutChecker) {
                blackListedKeyboardShortcutChecker.check(this);
            }
        }
        return KeyboardShortcutListener;
    }());
    (function (KeyboardKeys) {
        KeyboardKeys["Ctrl"] = "ctrl";
        KeyboardKeys["Alt"] = "alt";
        KeyboardKeys["Shift"] = "shift";
        KeyboardKeys["Escape"] = "escape";
    })(exports.KeyboardKeys || (exports.KeyboardKeys = {}));
    /**
     * @param bindings takes in the shortcut from KeyboardShortcutCombination which is an array of strings
     * @return {string}
     */
    function mapKeyboardShortcutCombination(bindings) {
        return JSON.stringify(bindings.map(function (key) { return key.toLowerCase(); }).sort());
    }
    // Map to normalized keys across different browser implementations.
    // https://github.com/angular/angular/blob/5.0.5/packages/platform-browser/src/browser/browser_adapter.ts#L25-L42
    // tslint:disable:object-literal-sort-keys
    /**
     * @constant
     * Map to convert some key or keyIdentifier values to what will be returned by getEventKey
     * This is also used to help browser compatibility and to match the W3C standard
     */
    var KEY_MAP = {
        '\b': 'backspace',
        '\t': 'tab',
        '\x1B': 'escape',
        '\x7F': 'delete',
        Del: 'delete',
        Esc: 'escape',
        Left: 'arrowleft',
        Right: 'arrowright',
        Up: 'arrowup',
        Down: 'arrowdown',
        Menu: 'contextMenu',
        Scroll: 'scrolllock',
        Win: 'os',
        ' ': 'space',
        '.': 'dot'
    };
    // tslint:enable:object-literal-sort-keys

    var blacklistedKeyCombinations = [
        [exports.KeyboardKeys.Ctrl, 'd'],
        [exports.KeyboardKeys.Ctrl, 'f'],
        [exports.KeyboardKeys.Ctrl, 'g'],
        [exports.KeyboardKeys.Ctrl, exports.KeyboardKeys.Shift, 'g'],
        [exports.KeyboardKeys.Ctrl, 'h'],
        [exports.KeyboardKeys.Ctrl, 'j'],
        [exports.KeyboardKeys.Ctrl, 'o'],
        [exports.KeyboardKeys.Ctrl, 's'],
        [exports.KeyboardKeys.Ctrl, 'p'],
        [exports.KeyboardKeys.Ctrl, 'u'],
        [exports.KeyboardKeys.Ctrl, 'n'],
        [exports.KeyboardKeys.Ctrl, 't'],
        [exports.KeyboardKeys.Ctrl, exports.KeyboardKeys.Shift, 't'],
        [exports.KeyboardKeys.Ctrl, 'c'],
        [exports.KeyboardKeys.Ctrl, 'x'],
        [exports.KeyboardKeys.Ctrl, 'v'],
        [exports.KeyboardKeys.Alt, 'f'],
        [exports.KeyboardKeys.Ctrl, '0'],
        [exports.KeyboardKeys.Ctrl, '1'],
        [exports.KeyboardKeys.Ctrl, '2'],
        [exports.KeyboardKeys.Ctrl, '3'],
        [exports.KeyboardKeys.Ctrl, '4'],
        [exports.KeyboardKeys.Ctrl, '5'],
        [exports.KeyboardKeys.Ctrl, '6'],
        [exports.KeyboardKeys.Ctrl, '7'],
        [exports.KeyboardKeys.Ctrl, '8'],
        [exports.KeyboardKeys.Ctrl, '9'],
        [exports.KeyboardKeys.Shift, '1'],
        [exports.KeyboardKeys.Shift, '2'],
        [exports.KeyboardKeys.Shift, '3'],
        [exports.KeyboardKeys.Shift, '4'],
        [exports.KeyboardKeys.Shift, '5'],
        [exports.KeyboardKeys.Shift, '6'],
        [exports.KeyboardKeys.Shift, '7'],
        [exports.KeyboardKeys.Shift, '8'],
        [exports.KeyboardKeys.Shift, '9'],
        [exports.KeyboardKeys.Shift, '0'],
        [exports.KeyboardKeys.Escape],
        [exports.KeyboardKeys.Ctrl, 'tab'],
        [exports.KeyboardKeys.Ctrl, exports.KeyboardKeys.Shift, 'tab'],
        [exports.KeyboardKeys.Ctrl, 'w'],
        [exports.KeyboardKeys.Alt, '4'],
        [exports.KeyboardKeys.Alt, 'arrowleft'],
        [exports.KeyboardKeys.Alt, 'backspace'],
        [exports.KeyboardKeys.Ctrl, exports.KeyboardKeys.Shift, 'delete'] // open the clear browsing history window
    ];
    var BlackListedKeyboardShortcutChecker = /** @class */ (function () {
        function BlackListedKeyboardShortcutChecker() {
            this.blackListedKeyBindings = blacklistedKeyCombinations;
            this.mappedBlackListedKeyBindings = this.blackListedKeyBindings.map(function (blkb) { return mapKeyboardShortcutCombination(blkb); });
        }
        BlackListedKeyboardShortcutChecker.prototype.check = function (listener) {
            var e_1, _a;
            try {
                // this is where the test was deleted
                for (var _b = __values(this.mappedBlackListedKeyBindings), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var blkb = _c.value;
                    if (blkb === listener.mappedKeyboardShortcutCombination) {
                        var warningMessage = "Keyboard Shortcut [" + listener.displayShortcutCombination + "] is blacklisted as a common keyboard shortcut.  Consider changing your keybinding for this shortcut.";
                        console.warn(warningMessage);
                        return;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        };
        return BlackListedKeyboardShortcutChecker;
    }());

    var KeyboardShortcutService = /** @class */ (function () {
        function KeyboardShortcutService(zone) {
            var _this = this;
            this._listeners = [];
            this.zone = zone;
            // Since we're going to create a root event-handler for the keydown event, we're
            // gonna do this outside of the NgZone. This way, we're not constantly triggering
            // change-detection for every key event - we'll only re-enter the Angular Zone
            // when we have an event that is actually being consumed by one of our components.
            this.zone.runOutsideAngular(function () {
                window.addEventListener('keydown', _this.handleKeyboardEvent.bind(_this));
            });
            // we only use this if isDevMode
            if (i0.isDevMode()) {
                this.blackListedKeyboardShortcutChecker = new BlackListedKeyboardShortcutChecker();
            }
        }
        Object.defineProperty(KeyboardShortcutService.prototype, "listeners_read_only", {
            /**
             * @readonly
             * @description A list of all available shortcut listeners
             * @property    {IKeyboardShortcutListener[]}
             */
            get: function () {
                return JSON.parse(JSON.stringify(this._listeners));
            },
            enumerable: false,
            configurable: true
        });
        /**
         * @description                     Creates a listenerHandle using imported interface
         * @param listenerConstructorObject Interface that contains a KeyboardShortcutHandler
         * @returns                         an IListenerHandle
         */
        KeyboardShortcutService.prototype.listen = function (listenerConstructorObject) {
            var listenerHandle = this.addListener(listenerConstructorObject);
            return listenerHandle;
        };
        KeyboardShortcutService.prototype.addListener = function (listenerConstructorObject) {
            var _this = this;
            var listener = new KeyboardShortcutListener(listenerConstructorObject, this.blackListedKeyboardShortcutChecker);
            var listenerHandle = {
                remove: function () {
                    _this.removeListener(listener);
                }
            };
            this._listeners.push(listener);
            this._listeners.sort(function (a, b) {
                if (a.priority < b.priority) {
                    return 1;
                }
                else if (a.priority > b.priority) {
                    return -1;
                }
                else {
                    return 0;
                }
            });
            return listenerHandle;
        };
        // get the keyCombination from the given event
        KeyboardShortcutService.prototype.getKeyFromEvent = function (event) {
            var keyIdentifier = 'keyIdentifier';
            var key = event.key || event[keyIdentifier] || 'Unidentified';
            if (key.startsWith('U+')) {
                key = String.fromCharCode(parseInt(key.slice(2), 16));
            }
            var parts = [(KEY_MAP[key] || key)];
            if (event.altKey) {
                parts.push(exports.KeyboardKeys.Alt);
            }
            if (event.ctrlKey) {
                parts.push(exports.KeyboardKeys.Ctrl);
            }
            if (event.shiftKey) {
                parts.push(exports.KeyboardKeys.Shift);
            }
            return mapKeyboardShortcutCombination(parts);
        };
        // handle the keyboard events for the root handler (and delegate to the listeners).
        KeyboardShortcutService.prototype.handleKeyboardEvent = function (event) {
            var e_1, _a;
            var keyCombination = this.getKeyFromEvent(event);
            var isInputEvent = this.isEventFromInput(event);
            var handler;
            try {
                // Iterate over the listeners in DESCENDING priority order.
                for (var _b = __values(this._listeners), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var listener = _c.value;
                    if (listener.mappedKeyboardShortcutCombination === keyCombination) {
                        handler = listener.handler;
                        // Execute handler if this is NOT an input event that we need to ignore.
                        if (!isInputEvent || !listener.ignoreEventsFromInputElement) {
                            // Right now, we're executing outside of the NgZone. As such, we
                            // have to re-enter the NgZone so that we can hook back into change-
                            // detection. Plus, this will also catch errors and propagate them
                            // through application properly.
                            this.zone.runGuarded(function () {
                                return handler(event);
                            });
                            // If the handler returned an explicit False, we're going to treat
                            // this listener as Terminal, regardless of the original settings.
                            if (!listener.passToLowerPriorities) {
                                return;
                            }
                            else {
                                continue;
                            }
                        }
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        };
        /**
         * @description Used for testing, Sends a keyboard event
         * @param event a keyboard event
         */
        KeyboardShortcutService.prototype.sendKeyboardEventToHandler = function (event) {
            this.handleKeyboardEvent(event);
        };
        // determine if the given event originated from a form input element.
        KeyboardShortcutService.prototype.isEventFromInput = function (event) {
            if (event.target instanceof Node) {
                switch (event.target.nodeName) {
                    case 'INPUT':
                    case 'SELECT':
                    case 'TEXTAREA':
                        return true;
                    default:
                        return false;
                }
            }
            return false;
        };
        // remove the given listener from the internal collection.
        KeyboardShortcutService.prototype.removeListener = function (listenerToRemove) {
            this._listeners = this._listeners.filter(function (listener) {
                return listener !== listenerToRemove;
            });
        };
        return KeyboardShortcutService;
    }());
    KeyboardShortcutService.ɵprov = i0.ɵɵdefineInjectable({ factory: function KeyboardShortcutService_Factory() { return new KeyboardShortcutService(i0.ɵɵinject(i0.NgZone)); }, token: KeyboardShortcutService, providedIn: "root" });
    KeyboardShortcutService.decorators = [
        { type: i0.Injectable, args: [{ providedIn: 'root' },] }
    ];
    KeyboardShortcutService.ctorParameters = function () { return [
        { type: i0.NgZone }
    ]; };

    var KeyboardShortcutDirective = /** @class */ (function () {
        function KeyboardShortcutDirective(elRef, keyboardShortcutService) {
            this.elRef = elRef;
            this.keyboardShortcutService = keyboardShortcutService;
            this.fireClickEventOnKeyboardShortcut = true;
            this.onKeyboardShortcut = new i0.EventEmitter();
        }
        KeyboardShortcutDirective.prototype.ngOnInit = function () {
            if (!this.keyboardShortcut) {
                return;
            }
            var listenerConstructor = {};
            Object.assign(listenerConstructor, { handler: this.keyboardShortcutHandler.bind(this) }, this.keyboardShortcut);
            this.listener = this.keyboardShortcutService.listen(listenerConstructor);
        };
        KeyboardShortcutDirective.prototype.keyboardShortcutHandler = function (event) {
            if (this.fireClickEventOnKeyboardShortcut) {
                if (this.elRef &&
                    this.elRef.nativeElement &&
                    this.elRef.nativeElement.click) {
                    this.elRef.nativeElement.click();
                }
            }
            this.onKeyboardShortcut.emit(event);
        };
        KeyboardShortcutDirective.prototype.ngOnDestroy = function () {
            if (this.listener) {
                this.listener.remove();
            }
        };
        return KeyboardShortcutDirective;
    }());
    KeyboardShortcutDirective.decorators = [
        { type: i0.Directive, args: [{
                    selector: '[keyboardShortcut]'
                },] }
    ];
    KeyboardShortcutDirective.ctorParameters = function () { return [
        { type: i0.ElementRef },
        { type: KeyboardShortcutService }
    ]; };
    KeyboardShortcutDirective.propDecorators = {
        keyboardShortcut: [{ type: i0.Input }],
        fireClickEventOnKeyboardShortcut: [{ type: i0.Input }],
        onKeyboardShortcut: [{ type: i0.Output }]
    };

    var NgxKeyboardShortcutModule = /** @class */ (function () {
        function NgxKeyboardShortcutModule() {
        }
        return NgxKeyboardShortcutModule;
    }());
    NgxKeyboardShortcutModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [KeyboardShortcutDirective],
                    exports: [KeyboardShortcutDirective],
                    imports: [common.CommonModule]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.KEY_MAP = KEY_MAP;
    exports.KeyboardShortcutDirective = KeyboardShortcutDirective;
    exports.KeyboardShortcutListener = KeyboardShortcutListener;
    exports.KeyboardShortcutService = KeyboardShortcutService;
    exports.NgxKeyboardShortcutModule = NgxKeyboardShortcutModule;
    exports.blacklistedKeyCombinations = blacklistedKeyCombinations;
    exports.mapKeyboardShortcutCombination = mapKeyboardShortcutCombination;
    exports.ɵa = BlackListedKeyboardShortcutChecker;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-keyboard-shortcuts.umd.js.map
