import { EventEmitter, OnDestroy, OnInit, ElementRef } from '@angular/core';
import { KeyboardShortcutService } from './keyboard-shortcut.service';
import { IKeyboardShortcutListenerOptions } from './libraries/listener.library';
export declare class KeyboardShortcutDirective implements OnInit, OnDestroy {
    private elRef;
    private keyboardShortcutService;
    keyboardShortcut: IKeyboardShortcutListenerOptions;
    fireClickEventOnKeyboardShortcut: boolean;
    onKeyboardShortcut: EventEmitter<KeyboardEvent>;
    private listener;
    constructor(elRef: ElementRef, keyboardShortcutService: KeyboardShortcutService);
    ngOnInit(): void;
    private keyboardShortcutHandler;
    ngOnDestroy(): void;
}
